/******************************************************************************
* 
* CAEN SpA - Front End Division
* Via Vetraia, 11 - 55049 - Viareggio ITALY
* +390594388398 - www.caen.it
*
***************************************************************************//**
* \note TERMS OF USE:
* This program is free software; you can redistribute it and/or modify it under
* the terms of the GNU General Public License as published by the Free Software
* Foundation. This program is distributed in the hope that it will be useful, 
* but WITHOUT ANY WARRANTY; without even the implied warranty of 
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. The user relies on the 
* software, documentation and results solely at his own risk.
*
* \file     CFE_OS_defs.h
* \brief    CAEN Front End - Operating System Definitions
* \author   Carlo Tintori (c.tintori@caen.it)
* \version  0.1
* \date     2008/11/03
*
* This header file contains some general definitions and includes that depends
* on the operating system (Windows or Linux)
******************************************************************************/

#ifndef __CFE_OS_DEFS_H
#define __CFE_OS_DEFS_H


#ifdef WIN32

    #ifndef _CRT_SECURE_NO_DEPRECATE
        #define _CRT_SECURE_NO_DEPRECATE
    #endif

    #include <time.h>
    #include <sys/timeb.h>
    #include <process.h>
    #include <windows.h>
    #include <winsock.h>

    #define PATH_SEPARATOR '\\'

    // redefine the 'deprecated' functions
    #define popen  _popen  
    #define pclose _pclose 

    #ifndef int8_t
        #define int8_t  INT8
    #endif
    #ifndef int16_t
        #define int16_t INT16
    #endif
    #ifndef int32_t
        #define int32_t INT32
    #endif
    #ifndef int64_t
        #define int64_t INT64
    #endif

    #ifndef uint8_t
        #define uint8_t  UINT8
    #endif
    #ifndef uint16_t
        #define uint16_t UINT16
    #endif
    #ifndef uint32_t
        #define uint32_t UINT32
    #endif
    #ifndef uint64_t
        #define uint64_t UINT64
    #endif

    #define msleep  Sleep

#else  // LINUX

    #include <unistd.h>
    #include <sys/time.h>
    #include <sys/types.h>
    #include <stdint.h>

    #define PATH_SEPARATOR '/'

    #define msleep(t)  usleep((t)*1000)
#endif

#endif