/******************************************************************************
* 
* CAEN SpA - Front End Division
* Via Vetraia, 11 - 55049 - Viareggio ITALY
* +390594388398 - www.caen.it
*
* \file     CFE_LINK.c
* \brief    CAEN Front End - Link for the access to the hardware devices
* \author   Carlo Tintori (c.tintori@caen.it)
* \version  0.1
* \date     2009/11/03
*
* This library provides the basic I/O functions for the access to the VME
* --- SBS bridge ---
******************************************************************************/


int CFE_LinkOpen(int LinkType, int LinkNumber, int DeviceNumber, int32_t *handle)
{
	*handle=0;
	return 0;
}


int CFE_LinkClose(int32_t handle);
{
	return 0;
}


int CFE_LinkWrite32(long handle, uint32_t address, uint32_t data); 
{
	*(uint32_t *)(address/4) = data;
	return 0;
}


int CFE_LinkRead32(long handle, uint32_t address, uint32_t *data); 
{
	*data = *(uint32_t *)(address/4);
	return 0;
}


int CFE_LinkReadBlock(long handle, uint32_t address, uint32_t *data, unit32_t size, uint32_t *nb); 
{
	int i, nw;

	// implement the block transfer as a sequence of single read accesses.
	// the transfer is terminated at the end of the event
	for(i=0; i<(size/4); i++) {
		data[i] = *(uint32_t *)(address/4);
		if (i==0)  // header
			nw = data[i] & 0x0FFFFFFF;  // nw = event size (in long words)
		else
			nw--;
		if (nw == 1)
			break;
	}
	*nb = i*4;
	return 0;
}
